Index: docs/howto/custom-model-fields.txt
===================================================================
--- docs/howto/custom-model-fields.txt	(revision 13446)
+++ docs/howto/custom-model-fields.txt	(working copy)
@@ -4,7 +4,6 @@
 Writing custom model fields
 ===========================
 
-.. versionadded:: 1.0
 .. currentmodule:: django.db.models
 
 Introduction
Index: docs/howto/custom-template-tags.txt
===================================================================
--- docs/howto/custom-template-tags.txt	(revision 13446)
+++ docs/howto/custom-template-tags.txt	(working copy)
@@ -157,8 +157,6 @@
 Filters and auto-escaping
 ~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 When writing a custom filter, give some thought to how the filter will interact
 with Django's auto-escaping behavior. Note that three types of strings can be
 passed around inside the template code:
@@ -428,8 +426,6 @@
 Auto-escaping considerations
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 The output from template tags is **not** automatically run through the
 auto-escaping filters. However, there are still a couple of things you should
 keep in mind when writing a template tag.
Index: docs/howto/custom-management-commands.txt
===================================================================
--- docs/howto/custom-management-commands.txt	(revision 13446)
+++ docs/howto/custom-management-commands.txt	(working copy)
@@ -4,8 +4,6 @@
 Writing custom django-admin commands
 ====================================
 
-.. versionadded:: 1.0
-
 Applications can register their own actions with ``manage.py``. For example,
 you might want to add a ``manage.py`` action for a Django app that you're
 distributing. In this document, we will be building a custom ``closepoll``
Index: docs/ref/models/querysets.txt
===================================================================
--- docs/ref/models/querysets.txt	(revision 13446)
+++ docs/ref/models/querysets.txt	(working copy)
@@ -307,8 +307,6 @@
 
 .. method:: reverse()
 
-.. versionadded:: 1.0
-
 Use the ``reverse()`` method to reverse the order in which a queryset's
 elements are returned. Calling ``reverse()`` a second time restores the
 ordering back to the normal direction.
@@ -465,8 +463,6 @@
 
 .. method:: values_list(*fields)
 
-.. versionadded:: 1.0
-
 This is similar to ``values()`` except that instead of returning dictionaries,
 it returns tuples when iterated over. Each tuple contains the value from the
 respective field passed into the ``values_list()`` call -- so the first item is
@@ -531,8 +527,6 @@
 
 .. method:: none()
 
-.. versionadded:: 1.0
-
 Returns an ``EmptyQuerySet`` -- a ``QuerySet`` that always evaluates to
 an empty list. This can be used in cases where you know that you should
 return an empty result set and your caller is expecting a ``QuerySet``
@@ -548,8 +542,6 @@
 
 .. method:: all()
 
-.. versionadded:: 1.0
-
 Returns a ''copy'' of the current ``QuerySet`` (or ``QuerySet`` subclass you
 pass in). This can be useful in some situations where you might want to pass
 in either a model manager or a ``QuerySet`` and do further filtering on the
@@ -1677,8 +1669,6 @@
 regex
 ~~~~~
 
-.. versionadded:: 1.0
-
 Case-sensitive regular expression match.
 
 The regular expression syntax is that of the database backend in use.
@@ -1708,8 +1698,6 @@
 iregex
 ~~~~~~
 
-.. versionadded:: 1.0
-
 Case-insensitive regular expression match.
 
 Example::
Index: docs/ref/models/fields.txt
===================================================================
--- docs/ref/models/fields.txt	(revision 13446)
+++ docs/ref/models/fields.txt	(working copy)
@@ -173,8 +173,6 @@
 
 .. attribute:: Field.db_tablespace
 
-.. versionadded:: 1.0
-
 The name of the database tablespace to use for this field's index, if this field
 is indexed. The default is the project's :setting:`DEFAULT_INDEX_TABLESPACE`
 setting, if set, or the :attr:`~Field.db_tablespace` of the model, if any. If
@@ -428,8 +426,6 @@
 ``DecimalField``
 ----------------
 
-.. versionadded:: 1.0
-
 .. class:: DecimalField(max_digits=None, decimal_places=None, [**options])
 
 A fixed-precision decimal number, represented in Python by a
Index: docs/ref/models/instances.txt
===================================================================
--- docs/ref/models/instances.txt	(revision 13446)
+++ docs/ref/models/instances.txt	(working copy)
@@ -170,8 +170,6 @@
 The ``pk`` property
 ~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. attribute:: Model.pk
 
 Regardless of whether you define a primary key field yourself, or let Django
@@ -280,8 +278,6 @@
 Forcing an INSERT or UPDATE
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 In some rare circumstances, it's necessary to be able to force the ``save()``
 method to perform an SQL ``INSERT`` and not fall back to doing an ``UPDATE``.
 Or vice-versa: update, if possible, but not insert a new row. In these cases
Index: docs/ref/models/options.txt
===================================================================
--- docs/ref/models/options.txt	(revision 13446)
+++ docs/ref/models/options.txt	(working copy)
@@ -67,8 +67,6 @@
 
 .. attribute:: Options.db_tablespace
 
-.. versionadded:: 1.0
-
 The name of the database tablespace to use for the model. If the backend doesn't
 support tablespaces, this option is ignored.
 
@@ -214,8 +212,6 @@
 appropriate ``UNIQUE`` statements are included in the ``CREATE TABLE``
 statement).
 
-.. versionadded:: 1.0
-
 For convenience, unique_together can be a single list when dealing with a single
 set of fields::
 
Index: docs/ref/generic-views.txt
===================================================================
--- docs/ref/generic-views.txt	(revision 13446)
+++ docs/ref/generic-views.txt	(working copy)
@@ -178,8 +178,6 @@
       specified in ``date_field`` is greater than the current date/time. By
       default, this is ``False``.
 
-    .. versionadded:: 1.0
-
     * ``template_object_name``: Designates the name of the template variable
       to use in the template context. By default, this is ``'latest'``.
 
@@ -204,9 +202,6 @@
       ordered in reverse. This is equivalent to
       ``queryset.dates(date_field, 'year')[::-1]``.
 
-    .. versionchanged:: 1.0
-       The behaviour depending on ``template_object_name`` is new in this version.
-
     * ``latest``: The ``num_latest`` objects in the system, ordered descending
       by ``date_field``. For example, if ``num_latest`` is ``10``, then
       ``latest`` will be a list of the latest 10 objects in ``queryset``.
@@ -723,9 +718,6 @@
 
 **Template context:**
 
-.. versionadded:: 1.0
-   The ``paginator`` and ``page_obj`` context variables are new.
-
 In addition to ``extra_context``, the template's context will be:
 
     * ``object_list``: The list of objects. This variable's name depends on the
Index: docs/ref/forms/fields.txt
===================================================================
--- docs/ref/forms/fields.txt	(revision 13446)
+++ docs/ref/forms/fields.txt	(working copy)
@@ -232,8 +232,6 @@
 ``error_messages``
 ~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. attribute:: Field.error_messages
 
 The ``error_messages`` argument lets you override the default messages that the
@@ -451,8 +449,6 @@
 ``DecimalField``
 ~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. class:: DecimalField(**kwargs)
 
     * Default widget: ``TextInput``
@@ -505,8 +501,6 @@
 ``FileField``
 ~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. class:: FileField(**kwargs)
 
     * Default widget: ``FileInput``
@@ -525,8 +519,6 @@
 ``FilePathField``
 ~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. class:: FilePathField(**kwargs)
 
     * Default widget: ``Select``
@@ -571,8 +563,6 @@
 ``ImageField``
 ~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. class:: ImageField(**kwargs)
 
     * Default widget: ``FileInput``
Index: docs/ref/forms/widgets.txt
===================================================================
--- docs/ref/forms/widgets.txt	(revision 13446)
+++ docs/ref/forms/widgets.txt	(working copy)
@@ -59,8 +59,6 @@
 
 .. class:: DateTimeInput
 
-    .. versionadded:: 1.0
-
     Date/time input as a simple text box: ``<input type='text' ...>``
 
     Takes one optional argument:
Index: docs/ref/middleware.txt
===================================================================
--- docs/ref/middleware.txt	(revision 13446)
+++ docs/ref/middleware.txt	(working copy)
@@ -185,8 +185,6 @@
 
 .. class:: django.middleware.csrf.CsrfMiddleware
 
-.. versionadded:: 1.0
-
 Adds protection against Cross Site Request Forgeries by adding hidden form
 fields to POST forms and checking requests for the correct value. See the
 :ref:`Cross Site Request Forgery protection documentation <ref-contrib-csrf>`.
Index: docs/ref/templates/api.txt
===================================================================
--- docs/ref/templates/api.txt	(revision 13446)
+++ docs/ref/templates/api.txt	(working copy)
@@ -428,8 +428,6 @@
 django.core.context_processors.media
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 If :setting:`TEMPLATE_CONTEXT_PROCESSORS` contains this processor, every
 ``RequestContext`` will contain a variable ``MEDIA_URL``, providing the
 value of the :setting:`MEDIA_URL` setting.
Index: docs/ref/templates/builtins.txt
===================================================================
--- docs/ref/templates/builtins.txt	(revision 13446)
+++ docs/ref/templates/builtins.txt	(working copy)
@@ -21,8 +21,6 @@
 autoescape
 ~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 Control the current auto-escaping behavior. This tag takes either ``on`` or
 ``off`` as an argument and that determines whether auto-escaping is in effect
 inside the block.
@@ -235,8 +233,6 @@
 
 You can loop over a list in reverse by using ``{% for obj in list reversed %}``.
 
-.. versionadded:: 1.0
-
 If you need to loop over a list of lists, you can unpack the values
 in each sub-list into individual variables. For example, if your context
 contains a list of (x,y) coordinates called ``points``, you could use the
@@ -1022,8 +1018,6 @@
 with
 ~~~~
 
-.. versionadded:: 1.0
-
 Caches a complex variable under a simpler name. This is useful when accessing
 an "expensive" method (e.g., one that hits the database) multiple times.
 
@@ -1284,8 +1278,6 @@
 escapejs
 ~~~~~~~~
 
-.. versionadded:: 1.0
-
 Escapes characters for use in JavaScript strings. This does *not* make the
 string safe for use in HTML, but does protect you from syntax errors when using
 templates to generate JavaScript/JSON.
@@ -1387,8 +1379,6 @@
 force_escape
 ~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 Applies HTML escaping to a string (see the ``escape`` filter for details).
 This filter is applied *immediately* and returns a new, escaped string. This
 is useful in the rare cases where you need multiple escaping or want to apply
@@ -1448,8 +1438,6 @@
 last
 ~~~~
 
-.. versionadded:: 1.0
-
 Returns the last item in a list.
 
 For example::
Index: docs/ref/contrib/gis/index.txt
===================================================================
--- docs/ref/contrib/gis/index.txt	(revision 13446)
+++ docs/ref/contrib/gis/index.txt	(working copy)
@@ -4,8 +4,6 @@
 GeoDjango
 =========
 
-.. versionadded:: 1.0
-
 .. module:: django.contrib.gis
    :synopsis: Geographic Information System (GIS) extensions for Django
 
Index: docs/ref/contrib/formtools/form-wizard.txt
===================================================================
--- docs/ref/contrib/formtools/form-wizard.txt	(revision 13446)
+++ docs/ref/contrib/formtools/form-wizard.txt	(working copy)
@@ -7,8 +7,6 @@
 .. module:: django.contrib.formtools.wizard
     :synopsis: Splits forms across multiple Web pages.
 
-.. versionadded:: 1.0
-
 Django comes with an optional "form wizard" application that splits
 :ref:`forms <topics-forms-index>` across multiple Web pages. It maintains
 state in hashed HTML :samp:`<input type="hidden">` fields, and the data isn't
Index: docs/ref/contrib/humanize.txt
===================================================================
--- docs/ref/contrib/humanize.txt	(revision 13446)
+++ docs/ref/contrib/humanize.txt	(working copy)
@@ -74,8 +74,6 @@
 naturalday
 ----------
 
-.. versionadded:: 1.0
-
 For dates that are the current day or within one day, return "today",
 "tomorrow" or "yesterday", as appropriate. Otherwise, format the date using
 the passed in format string.
Index: docs/ref/contrib/sites.txt
===================================================================
--- docs/ref/contrib/sites.txt	(revision 13446)
+++ docs/ref/contrib/sites.txt	(working copy)
@@ -230,8 +230,6 @@
 Caching the current ``Site`` object
 ===================================
 
-.. versionadded:: 1.0
-
 As the current site is stored in the database, each call to
 ``Site.objects.get_current()`` could result in a database query. But Django is a
 little cleverer than that: on the first request, the current site is cached, and
@@ -385,8 +383,6 @@
 
 .. _requestsite-objects:
 
-.. versionadded:: 1.0
-
 Some :ref:`django.contrib <ref-contrib-index>` applications take advantage of
 the sites framework but are architected in a way that doesn't *require* the
 sites framework to be installed in your database. (Some people don't want to, or
Index: docs/ref/request-response.txt
===================================================================
--- docs/ref/request-response.txt	(revision 13446)
+++ docs/ref/request-response.txt	(working copy)
@@ -49,8 +49,6 @@
 
 .. attribute:: HttpRequest.encoding
 
-    .. versionadded:: 1.0
-
     A string representing the current encoding used to decode form submission
     data (or ``None``, which means the ``DEFAULT_CHARSET`` setting is used).
     You can write to this attribute to change the encoding used when accessing
@@ -191,8 +189,6 @@
 
 .. method:: HttpRequest.get_host()
 
-   .. versionadded:: 1.0
-
    Returns the originating host of the request using information from the
    ``HTTP_X_FORWARDED_HOST`` and ``HTTP_HOST`` headers (in that order). If
    they don't provide a value, the method uses a combination of
@@ -210,8 +206,6 @@
 
 .. method:: HttpRequest.build_absolute_uri(location)
 
-   .. versionadded:: 1.0
-
    Returns the absolute URI form of ``location``. If no location is provided,
    the location will be set to ``request.get_full_path()``.
 
@@ -228,8 +222,6 @@
 
 .. method:: HttpRequest.is_ajax()
 
-   .. versionadded:: 1.0
-
    Returns ``True`` if the request was made via an ``XMLHttpRequest``, by
    checking the ``HTTP_X_REQUESTED_WITH`` header for the string
    ``'XMLHttpRequest'``. Most modern JavaScript libraries send this header.
@@ -578,8 +570,6 @@
 
 .. class:: HttpResponseBadRequest
 
-    .. versionadded:: 1.0
-
     Acts just like :class:`HttpResponse` but uses a 400 status code.
 
 .. class:: HttpResponseNotFound
Index: docs/ref/unicode.txt
===================================================================
--- docs/ref/unicode.txt	(revision 13446)
+++ docs/ref/unicode.txt	(working copy)
@@ -4,8 +4,6 @@
 Unicode data
 ============
 
-.. versionadded:: 1.0
-
 Django natively supports Unicode data everywhere. Providing your database can
 somehow store the data, you can safely pass around Unicode strings to
 templates, models and the database.
Index: docs/ref/django-admin.txt
===================================================================
--- docs/ref/django-admin.txt	(revision 13446)
+++ docs/ref/django-admin.txt	(working copy)
@@ -90,8 +90,6 @@
 
 .. django-admin:: cleanup
 
-.. versionadded:: 1.0
-
 Can be run as a cronjob or directly to clean out old data from the database
 (only expired sessions at the moment).
 
@@ -100,9 +98,6 @@
 
 .. django-admin:: compilemessages
 
-.. versionchanged:: 1.0
-   Before 1.0 this was the "bin/compile-messages.py" command.
-
 Compiles .po files created with ``makemessages`` to .mo files for use with
 the builtin gettext support. See :ref:`topics-i18n`.
 
@@ -131,8 +126,6 @@
 
 .. django-admin:: createsuperuser
 
-.. versionadded:: 1.0
-
 Creates a superuser account (a user who has all permissions). This is
 useful if you need to create an initial superuser account but did not
 do so during ``syncdb``, or if you need to programmatically generate
@@ -831,8 +824,6 @@
 
 .. django-admin:: testserver
 
-.. versionadded:: 1.0
-
 Runs a Django development server (as in ``runserver``) using data from the
 given fixture(s).
 
Index: docs/ref/settings.txt
===================================================================
--- docs/ref/settings.txt	(revision 13446)
+++ docs/ref/settings.txt	(working copy)
@@ -513,8 +513,6 @@
 DEBUG_PROPAGATE_EXCEPTIONS
 --------------------------
 
-.. versionadded:: 1.0
-
 Default: ``False``
 
 If set to True, Django's normal exception handling of view functions
@@ -578,8 +576,6 @@
 DEFAULT_TABLESPACE
 ------------------
 
-.. versionadded:: 1.0
-
 Default: ``''`` (Empty string)
 
 Default tablespace to use for models that don't specify one, if the
@@ -590,8 +586,6 @@
 DEFAULT_INDEX_TABLESPACE
 ------------------------
 
-.. versionadded:: 1.0
-
 Default: ``''`` (Empty string)
 
 Default tablespace to use for indexes on fields that don't specify
@@ -694,8 +688,6 @@
 EMAIL_USE_TLS
 -------------
 
-.. versionadded:: 1.0
-
 Default: ``False``
 
 Whether to use a TLS (secure) connection when talking to the SMTP server.
@@ -705,8 +697,6 @@
 FILE_CHARSET
 ------------
 
-.. versionadded:: 1.0
-
 Default: ``'utf-8'``
 
 The character encoding used to decode any files read from disk. This includes
@@ -717,8 +707,6 @@
 FILE_UPLOAD_HANDLERS
 --------------------
 
-.. versionadded:: 1.0
-
 Default::
 
     ("django.core.files.uploadhandler.MemoryFileUploadHandler",
@@ -731,8 +719,6 @@
 FILE_UPLOAD_MAX_MEMORY_SIZE
 ---------------------------
 
-.. versionadded:: 1.0
-
 Default: ``2621440`` (i.e. 2.5 MB).
 
 The maximum size (in bytes) that an upload will be before it gets streamed to
@@ -743,8 +729,6 @@
 FILE_UPLOAD_TEMP_DIR
 --------------------
 
-.. versionadded:: 1.0
-
 Default: ``None``
 
 The directory to store data temporarily while uploading files. If ``None``,
@@ -918,8 +902,6 @@
 LANGUAGE_COOKIE_NAME
 --------------------
 
-.. versionadded:: 1.0
-
 Default: ``'django_language'``
 
 The name of the cookie to use for the language cookie. This can be whatever you
@@ -984,8 +966,6 @@
 LOGIN_REDIRECT_URL
 ------------------
 
-.. versionadded:: 1.0
-
 Default: ``'/accounts/profile/'``
 
 The URL where requests are redirected after login when the
@@ -999,8 +979,6 @@
 LOGIN_URL
 ---------
 
-.. versionadded:: 1.0
-
 Default: ``'/accounts/login/'``
 
 The URL where requests are redirected for login, especially when using the
@@ -1011,8 +989,6 @@
 LOGOUT_URL
 ----------
 
-.. versionadded:: 1.0
-
 Default: ``'/accounts/logout/'``
 
 LOGIN_URL counterpart.
@@ -1232,8 +1208,6 @@
 SESSION_ENGINE
 --------------
 
-.. versionadded:: 1.0
-
 .. versionchanged:: 1.1
    The ``cached_db`` backend was added
 
@@ -1283,8 +1257,6 @@
 SESSION_COOKIE_PATH
 -------------------
 
-.. versionadded:: 1.0
-
 Default: ``'/'``
 
 The path set on the session cookie. This should either match the URL path of your
@@ -1321,8 +1293,6 @@
 SESSION_FILE_PATH
 -----------------
 
-.. versionadded:: 1.0
-
 Default: ``None``
 
 If you're using file-based session storage, this sets the directory in
Index: docs/topics/http/file-uploads.txt
===================================================================
--- docs/topics/http/file-uploads.txt	(revision 13446)
+++ docs/topics/http/file-uploads.txt	(working copy)
@@ -6,8 +6,6 @@
 
 .. currentmodule:: django.core.files
 
-.. versionadded:: 1.0
-
 When Django handles a file upload, the file data ends up placed in
 :attr:`request.FILES <django.http.HttpRequest.FILES>` (for more on the
 ``request`` object see the documentation for :ref:`request and response objects
Index: docs/topics/http/urls.txt
===================================================================
--- docs/topics/http/urls.txt	(revision 13446)
+++ docs/topics/http/urls.txt	(working copy)
@@ -225,8 +225,6 @@
 url
 ---
 
-.. versionadded:: 1.0
-
 .. function:: url(regex, view, kwargs=None, name=None, prefix='')
 
 You can use the ``url()`` function, instead of a tuple, as an argument to
@@ -636,8 +634,6 @@
 Naming URL patterns
 ===================
 
-.. versionadded:: 1.0
-
 It's fairly common to use the same view function in multiple URL patterns in
 your URLconf. For example, these two URL patterns both point to the ``archive``
 view::
Index: docs/topics/http/sessions.txt
===================================================================
--- docs/topics/http/sessions.txt	(revision 13446)
+++ docs/topics/http/sessions.txt	(working copy)
@@ -31,8 +31,6 @@
 Configuring the session engine
 ==============================
 
-.. versionadded:: 1.0
-
 By default, Django stores sessions in your database (using the model
 ``django.contrib.sessions.models.Session``). Though this is convenient, in
 some setups it's faster to store session data elsewhere, so Django can be
@@ -140,15 +138,10 @@
 
     * ``clear()``
 
-.. versionadded:: 1.0
-   ``setdefault()`` and ``clear()`` are new in this version.
-
 It also has these methods:
 
     * ``flush()``
 
-      .. versionadded:: 1.0
-
       Delete the current session data from the session and regenerate the
       session key value that is sent back to the user in the cookie. This is
       used if you want to ensure that the previous session data can't be
@@ -175,8 +168,6 @@
 
     * ``set_expiry(value)``
 
-      .. versionadded:: 1.0
-
       Sets the expiration time for the session. You can pass a number of
       different values:
 
@@ -200,24 +191,18 @@
 
     * ``get_expiry_age()``
 
-      .. versionadded:: 1.0
-
       Returns the number of seconds until this session expires. For sessions
       with no custom expiration (or those set to expire at browser close), this
       will equal ``settings.SESSION_COOKIE_AGE``.
 
     * ``get_expiry_date()``
 
-      .. versionadded:: 1.0
-
       Returns the date this session will expire. For sessions with no custom
       expiration (or those set to expire at browser close), this will equal the
       date ``settings.SESSION_COOKIE_AGE`` seconds from now.
 
     * ``get_expire_at_browser_close()``
 
-      .. versionadded:: 1.0
-
       Returns either ``True`` or ``False``, depending on whether the user's
       session cookie will expire when the user's Web browser is closed.
 
@@ -304,8 +289,6 @@
 Using sessions out of views
 ===========================
 
-.. versionadded:: 1.0
-
 An API is available to manipulate session data outside of a view::
 
     >>> from django.contrib.sessions.backends.db import SessionStore
@@ -417,8 +400,6 @@
 SESSION_ENGINE
 --------------
 
-.. versionadded:: 1.0
-
 .. versionchanged:: 1.1
    The ``cached_db`` backend was added
 
@@ -436,8 +417,6 @@
 SESSION_FILE_PATH
 -----------------
 
-.. versionadded:: 1.0
-
 Default: ``/tmp/``
 
 If you're using file-based session storage, this sets the directory in
@@ -469,8 +448,6 @@
 SESSION_COOKIE_PATH
 -------------------
 
-.. versionadded:: 1.0
-
 Default: ``'/'``
 
 The path set on the session cookie. This should either match the URL path of
Index: docs/topics/http/shortcuts.txt
===================================================================
--- docs/topics/http/shortcuts.txt	(revision 13446)
+++ docs/topics/http/shortcuts.txt	(working copy)
@@ -49,9 +49,6 @@
                                   context_instance=RequestContext(request))
 
 ``mimetype``
-
-    .. versionadded:: 1.0
-
     The MIME type to use for the resulting document. Defaults to the value of
     the :setting:`DEFAULT_CONTENT_TYPE` setting.
 
Index: docs/topics/auth.txt
===================================================================
--- docs/topics/auth.txt	(revision 13446)
+++ docs/topics/auth.txt	(working copy)
@@ -192,8 +192,6 @@
 
     .. method:: models.User.set_unusable_password()
 
-        .. versionadded:: 1.0
-
         Marks the user as having no password set.  This isn't the same as
         having a blank string for a password.
         :meth:`~django.contrib.auth.models.User.check_password()` for this user
@@ -205,8 +203,6 @@
 
     .. method:: models.User.has_usable_password()
 
-        .. versionadded:: 1.0
-
         Returns ``False`` if
         :meth:`~django.contrib.auth.models.User.set_unusable_password()` has
         been called for this user.
@@ -397,9 +393,6 @@
 only supported on platforms that have the standard Python ``crypt`` module
 available.
 
-.. versionadded:: 1.0
-    Support for the ``crypt`` module is new in Django 1.0.
-
 For example::
 
     sha1$a1976$a36cc8cbf81742a8fb52e221aaeab48ed7f58ab4
@@ -452,9 +445,6 @@
 Creating superusers
 -------------------
 
-.. versionadded:: 1.0
-   The ``manage.py createsuperuser`` command is new.
-
 :djadmin:`manage.py syncdb <syncdb>` prompts you to create a superuser the
 first time you run it after adding ``'django.contrib.auth'`` to your
 :setting:`INSTALLED_APPS`. If you need to create a superuser at a later date,
Index: docs/topics/files.txt
===================================================================
--- docs/topics/files.txt	(revision 13446)
+++ docs/topics/files.txt	(working copy)
@@ -4,8 +4,6 @@
 Managing files
 ==============
 
-.. versionadded:: 1.0
-
 This document describes Django's file access APIs.
 
 By default, Django stores files locally, using the :setting:`MEDIA_ROOT` and
Index: docs/topics/cache.txt
===================================================================
--- docs/topics/cache.txt	(revision 13446)
+++ docs/topics/cache.txt	(working copy)
@@ -197,8 +197,6 @@
 Using a custom cache backend
 ----------------------------
 
-.. versionadded:: 1.0
-
 While Django includes support for a number of cache backends out-of-the-box,
 sometimes you might want to use a customized cache backend. To use an external
 cache backend with Django, use a Python import path as the scheme portion (the
@@ -400,8 +398,6 @@
 Template fragment caching
 =========================
 
-.. versionadded:: 1.0
-
 If you're after even more control, you can also cache template fragments using
 the ``cache`` template tag. To give your template access to this tag, put
 ``{% load cache %}`` near the top of your template.
Index: docs/topics/db/models.txt
===================================================================
--- docs/topics/db/models.txt	(revision 13446)
+++ docs/topics/db/models.txt	(working copy)
@@ -389,8 +389,6 @@
 Extra fields on many-to-many relationships
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 When you're only dealing with simple many-to-many relationships such as
 mixing and matching pizzas and toppings, a standard :class:`~django.db.models.ManyToManyField` is all you need. However, sometimes
 you may need to associate data with the relationship between two models.
@@ -607,8 +605,6 @@
 Custom field types
 ------------------
 
-.. versionadded:: 1.0
-
 If one of the existing model fields cannot be used to fit your purposes, or if
 you wish to take advantage of some less common database column types, you can
 create your own field class. Full coverage of creating your own fields is
@@ -770,8 +766,6 @@
 Model inheritance
 =================
 
-.. versionadded:: 1.0
-
 Model inheritance in Django works almost identically to the way normal
 class inheritance works in Python. The only decision you have to make
 is whether you want the parent models to be models in their own right
Index: docs/topics/db/queries.txt
===================================================================
--- docs/topics/db/queries.txt	(revision 13446)
+++ docs/topics/db/queries.txt	(working copy)
@@ -439,8 +439,6 @@
 Spanning multi-valued relationships
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 When you are filtering an object based on a ``ManyToManyField`` or a reverse
 ``ForeignKey``, there are two different sorts of filter you may be
 interested in. Consider the ``Blog``/``Entry`` relationship (``Blog`` to
@@ -768,8 +766,6 @@
 Updating multiple objects at once
 =================================
 
-.. versionadded:: 1.0
-
 Sometimes you want to set a field to a particular value for all the objects in
 a ``QuerySet``. You can do this with the ``update()`` method. For example::
 
Index: docs/topics/forms/modelforms.txt
===================================================================
--- docs/topics/forms/modelforms.txt	(revision 13446)
+++ docs/topics/forms/modelforms.txt	(working copy)
@@ -108,10 +108,6 @@
     ===============================  ========================================
 
 
-.. versionadded:: 1.0
-    The ``FloatField`` form field and ``DecimalField`` model and form fields
-    are new in Django 1.0.
-
 .. versionadded:: 1.2
     The ``BigIntegerField`` is new in Django 1.2.
 
Index: docs/topics/testing.txt
===================================================================
--- docs/topics/testing.txt	(revision 13446)
+++ docs/topics/testing.txt	(working copy)
@@ -258,9 +258,6 @@
 
 Note that we used ``animals``, not ``myproject.animals``.
 
-.. versionadded:: 1.0
-   You can now choose which test to run.
-
 You can be even *more* specific by naming an individual test case. To
 run a single test case in an application (for example, the
 ``AnimalTestCase`` described in the "Writing unit tests" section), add
@@ -749,8 +746,6 @@
 
     .. method:: Client.login(**credentials)
 
-        .. versionadded:: 1.0
-
         If your site uses Django's :ref:`authentication system<topics-auth>`
         and you deal with logging in users, you can use the test client's
         ``login()`` method to simulate the effect of a user logging into the
@@ -795,8 +790,6 @@
 
     .. method:: Client.logout()
 
-        .. versionadded:: 1.0
-
         If your site uses Django's :ref:`authentication system<topics-auth>`,
         the ``logout()`` method can be used to simulate the effect of a user
         logging out of your site.
@@ -999,8 +992,6 @@
 Default test client
 ~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. attribute:: TestCase.client
 
 Every test case in a ``django.test.TestCase`` instance has access to an
@@ -1103,8 +1094,6 @@
 URLconf configuration
 ~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. attribute:: TestCase.urls
 
 If your application provides views, you may want to include tests that use the
@@ -1172,8 +1161,6 @@
 Emptying the test outbox
 ~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 If you use Django's custom ``TestCase`` class, the test runner will clear the
 contents of the test e-mail outbox at the start of each test case.
 
@@ -1182,8 +1169,6 @@
 Assertions
 ~~~~~~~~~~
 
-.. versionadded:: 1.0
-
 .. versionchanged:: 1.2
     Addded ``msg_prefix`` argument.
 
@@ -1266,8 +1251,6 @@
 E-mail services
 ---------------
 
-.. versionadded:: 1.0
-
 If any of your Django views send e-mail using :ref:`Django's e-mail
 functionality <topics-email>`, you probably don't want to send e-mail each time
 you run a test using that view. For this reason, Django's test runner
Index: docs/topics/email.txt
===================================================================
--- docs/topics/email.txt	(revision 13446)
+++ docs/topics/email.txt	(working copy)
@@ -198,8 +198,6 @@
 The EmailMessage class
 ======================
 
-.. versionadded:: 1.0
-
 Django's :meth:`~django.core.mail.send_mail()` and
 :meth:`~django.core.mail.send_mass_mail()` functions are actually thin
 wrappers that make use of the :class:`~django.core.mail.EmailMessage` class.
Index: docs/topics/templates.txt
===================================================================
--- docs/topics/templates.txt	(revision 13446)
+++ docs/topics/templates.txt	(working copy)
@@ -392,8 +392,6 @@
 Automatic HTML escaping
 =======================
 
-.. versionadded:: 1.0
-
 When generating HTML from templates, there's always a risk that a variable will
 include characters that affect the resulting HTML. For example, consider this
 template fragment::